package dev.shadowsoffire.apotheosis.adventure.gen;

import net.minecraft.world.item.ItemStack;
import net.minecraft.nbt.Tag;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemRegistry;
import net.minecraft.world.level.Level;
import dev.shadowsoffire.placebo.reload.WeightedDynamicRegistry;
import java.util.function.Predicate;
import net.minecraft.util.RandomSource;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.level.ServerLevelAccessor;
import net.minecraft.world.level.levelgen.structure.templatesystem.StructurePlaceSettings;
import net.minecraft.world.level.levelgen.structure.templatesystem.StructureTemplate;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.LevelReader;
import dev.shadowsoffire.apotheosis.adventure.Adventure;
import net.minecraft.world.level.levelgen.structure.templatesystem.StructureProcessorType;
import net.minecraft.resources.ResourceLocation;
import com.mojang.serialization.Codec;
import net.minecraft.world.level.levelgen.structure.templatesystem.StructureProcessor;

public class ItemFrameGemsProcessor extends StructureProcessor
{
    public static final Codec<ItemFrameGemsProcessor> CODEC;
    protected final ResourceLocation lootTable;
    
    public ItemFrameGemsProcessor(final ResourceLocation lootTable) {
        this.lootTable = lootTable;
    }
    
    protected StructureProcessorType<?> m_6953_() {
        return (StructureProcessorType<?>)Adventure.Features.ITEM_FRAME_GEMS.get();
    }
    
    public StructureTemplate.StructureEntityInfo processEntity(final LevelReader world, final BlockPos seedPos, final StructureTemplate.StructureEntityInfo rawEntityInfo, final StructureTemplate.StructureEntityInfo entityInfo, final StructurePlaceSettings placementSettings, final StructureTemplate template) {
        final CompoundTag entityNBT = entityInfo.f_74685_;
        final String id = entityNBT.m_128461_("id");
        if (world instanceof final ServerLevelAccessor sla) {
            if ("minecraft:item_frame".equals(id)) {
                this.writeEntityNBT(sla.m_6018_(), entityInfo.f_74684_, placementSettings.m_230326_(entityInfo.f_74684_), entityNBT, placementSettings);
            }
        }
        return entityInfo;
    }
    
    protected void writeEntityNBT(final ServerLevel world, final BlockPos pos, final RandomSource rand, final CompoundTag nbt, final StructurePlaceSettings settings) {
        final ItemStack stack = GemRegistry.createRandomGemStack(rand, world, 0.0f, new Predicate[] { WeightedDynamicRegistry.IDimensional.matches((Level)world) });
        nbt.m_128365_("Item", (Tag)stack.serializeNBT());
        nbt.m_128405_("TileX", pos.m_123341_());
        nbt.m_128405_("TileY", pos.m_123342_());
        nbt.m_128405_("TileZ", pos.m_123343_());
    }
    
    static {
        CODEC = Codec.unit((Object)new ItemFrameGemsProcessor(null));
    }
}
